namespace WebApplication10;

public class BookShelf
{
    private int _nextIdx = 0;
    private Dictionary<int, Book> _books { get; set; } = new();

    public BookShelf()
    {
        Add(new Book { Id = 0, Title = "The Alchemist", Author = "Paulo Coelho" });
        Add(new Book { Id = 1, Title = "The Little Prince", Author = "Antoine de Saint-Exupéry" });
        Add(new Book { Id = 2, Title = "The Hobbit", Author = "J. R. R. Tolkien"});
        Add(new Book { Id = 3, Title = "Doctor Zhivago", Author = "Boris Pasternak"});
        Add(new Book { Id = 4, Title = "The Fellowship Of The Ring", Author = "J. R. R. Tolkien"});
        Add(new Book { Id = 5, Title = "The Name Of The Wind", Author = "Patrick Rothfuss"});
        Add(new Book { Id = 6, Title = "The Alchemist", Author = "Paulo Coelho" });
        Add(new Book { Id = 7, Title = "The Little Prince", Author = "Antoine de Saint-Exupéry" });
        Add(new Book { Id = 8, Title = "The Hobbit", Author = "J. R. R. Tolkien"});
        Add(new Book { Id = 9, Title = "Doctor Zhivago", Author = "Boris Pasternak"});
        Add(new Book { Id = 10, Title = "The Fellowship Of The Ring", Author = "J. R. R. Tolkien"});
        Add(new Book { Id = 11, Title = "The Name Of The Wind", Author = "Patrick Rothfuss"});
    }

    public IEnumerable<Book> GetBooks(string authorPrefix, int page, int pageSize)
    {
        var query = _books.AsQueryable();
        if (!string.IsNullOrEmpty(authorPrefix))
            query = query.Where(b => b.Value.Author.StartsWith(authorPrefix));
        return query.Skip((page - 1) * pageSize).Take(pageSize).Select(kv => kv.Value).ToList();
    }

    public int GetCount(string authorPrefix)
    {
        var query = _books.AsQueryable();
        if (!string.IsNullOrEmpty(authorPrefix))
            query = query.Where(b => b.Value.Author.StartsWith(authorPrefix));
        return query.Count();
    }
    
    public IEnumerable<Book> GetAll()
    {
        return _books.Values.ToList();
    }

    public Book Add(Book book)
    {
        book.Id = _nextIdx;
        _nextIdx++;
        _books[book.Id] = book;
        return book;
    }

    public bool Update(Book book)
    {
        if (!_books.ContainsKey(book.Id))
            return false;
        _books[book.Id] = book;
        return true;
    }

    public void Delete(int id)
    {
        _books.Remove(id);
    }
}