using System.Security.Claims;
using Microsoft.AspNetCore.Authentication;
using Microsoft.AspNetCore.Authentication.Cookies;
using Microsoft.AspNetCore.Mvc;

namespace WebApplication10.Controllers;

[ApiController]
[Route("[controller]")]
public class UserController: ControllerBase
{
    private readonly List<User> _users;

    public UserController(List<User> users)
    {
        _users = users;
    }

    [HttpPost]
    [Route("login")]
    public IActionResult Login(User user)
    {
        User? findUser = _users.FirstOrDefault(u => u.Username == user.Username && u.Password == user.Password);
        // если пользователь не найден, отправляем статусный код 401
        if(findUser is null)
            return Unauthorized();
        
        var claims = new List<Claim>
        {
            new (ClaimTypes.Name, findUser.Username),
            new (ClaimTypes.Role, findUser.Role)
        };
        ClaimsIdentity claimsIdentity = new ClaimsIdentity(claims, CookieAuthenticationDefaults.AuthenticationScheme);
        HttpContext.SignInAsync(CookieAuthenticationDefaults.AuthenticationScheme, new ClaimsPrincipal(claimsIdentity));
        return Ok(new {user = findUser.Username});
    }
}